import { CallOptions } from '../utils/options';
import { Promise } from 'q';
import { CrudAccessControl, Grant } from './access-control.authorization';
import { Response } from 'express';
import { Model, Document, DocumentQuery } from 'mongoose';
export declare class AccessControlBaseController {
    private model;
    promisedAc: Promise<CrudAccessControl>;
    constructor(model: Model<Document>, grants: any);
    create(req: any, res: Response, options: CallOptions): Promise<any>;
    find(req: any, res: Response, exQueryBuilder?: (DocumentQuery: any) => DocumentQuery<any, any>, options?: CallOptions): Promise<any>;
    findById(req: any, res: Response, exQueryBuilder?: (DocumentQuery: any) => DocumentQuery<any, any>, options?: CallOptions): Promise<any>;
    restrictedQueryBuilderFactory(grant: Grant, user: any, exQueryBuilder?: any): () => (query: any) => any;
    update(req: any, res: Response, options?: CallOptions): Promise<any>;
    updateOp(req: any, res: Response, update: any, options?: CallOptions): Promise<any>;
    patch(req: any, res: Response, options?: CallOptions): Promise<any>;
    patchCustom(req: any, res: Response, createPatch: (any: any) => {}, options?: CallOptions): Promise<any>;
    remove(req: any, res: Response, options?: CallOptions): Promise<any>;
    private setOwner;
    private isLean;
    private applyBeforeUpdateIfDefined;
    private applyAfterUpdateIfDefined;
    private entityFromBody;
}
