'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
var logger_1 = require("../logger");
var access_control_authorization_1 = require("./access-control.authorization");
var Q = require('q');
var _ = require('lodash');
function crudAccessControlWithOrgRolesFactory(resource, grants) {
    if (!resource || !grants)
        throw Error('missing parameters');
    var thisGrants = _.cloneDeep(grants);
    thisGrants.forEach(function (grant) { grant.resource = grant.resource || resource; });
    return Q.when(thisGrants)
        .then(instantiateCrudAccessControl(resource));
}
exports.crudAccessControlWithOrgRolesFactory = crudAccessControlWithOrgRolesFactory;
function instantiateCrudAccessControl(resource) {
    return function (grants) {
        logger_1.default.trace("instantiate CrudAccessControl '" + resource + "' and '" + grants.length + " grants'");
        return new access_control_authorization_1.CrudAccessControl(resource, grants);
    };
}
