"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ip6addr = require("ip6addr");
var createError = require('http-errors');
var logger_1 = require("../logger");
function parseIp(req, res, next) {
    try {
        var ip = (req.headers['x-forwarded-for'] || '').split(',').pop() ||
            req.connection.remoteAddress ||
            req.socket.remoteAddress ||
            req.connection.socket.remoteAddress;
        var addr = ip6addr.parse(ip);
        if (addr.kind() === 'ipv4') {
            req.parsedIp = addr.toString({ format: 'v4' });
        }
        else {
            req.parsedIp = addr.toString({ format: 'auto' });
        }
        next();
    }
    catch (err) {
        logger_1.default.error(err);
        next(createError(500, err));
    }
}
exports.parseIp = parseIp;
